/*____________________________________________________________________________
	Copyright (C) 1994-1998 Network Associates Inc. and affiliated companies.
	All rights reserved.
	
	$Id: PGPDiskUtils.h,v 1.11 1999/03/15 17:43:32 heller Exp $
____________________________________________________________________________*/

#pragma once

#include "CComboError.h"
#include "PGPDisk.h"
#include "PGPDiskFileFormat.h"
#include "pgpKeys.h"

typedef struct PGPDiskFileInfo
{
	Boolean		fileIsOnLockedVolume;
	Boolean		fileIsLocked;
	Boolean		fileIsOpen;
	Boolean		fileIsInUseByDriver;
	Boolean		fileIsMounted;
	short		fileDriveNumber;	// Valid if fileIsInUseByDriver == TRUE

} PGPDiskFileInfo;

typedef OSStatus	(*MountDiskProgressProcPtr)(UInt32 percentComplete,
							void *userValue);

CComboError	MountPGPDisk(PGPContextRef context, const FSSpec *file,
					Boolean firstTime, Boolean mountReadOnly,
					const uchar *passphrase, Boolean allowRecoveryUI,
					ConstStr255Param newVolumeName,
					MountDiskProgressProcPtr progressProc,
					void *progressUserValue);
OSStatus	GetPGPDiskFileInfo(const FSSpec *fileSpec,
					PGPDiskFileInfo *fileInfo);

OSStatus	CheckForLocalPGPDiskVolume(short vRefNum);

OSStatus	VerifyPassphrase(PGPContextRef context, const FSSpec *file,
					const uchar *passphrase);
OSStatus	VerifyMasterPassphrase(PGPContextRef context, const FSSpec *file,
					const uchar *passphrase);

OSStatus	ChangePassphrase(PGPContextRef context, const FSSpec *fileSpec,
					const uchar *oldPassphrase, const uchar *newPassphrase);
OSStatus	AddPassphrase(PGPContextRef context, const FSSpec * spec,
					ConstStr255Param masterPassphrase,
					ConstStr255Param newPassphrase, Boolean readOnly );
OSStatus	RemovePassphrase(PGPContextRef context, const FSSpec * spec,
					ConstStr255Param passphrase );
OSStatus	RemoveAlternatePassphrases(PGPContextRef context,
					const FSSpec *fileSpec);

void		GetAllPGPDiskDrivers( short driverRefNums[], ushort maxRefNums,
					ushort * numDrivers);
void		GetAllPGPDrives( short driveNumbers[], ushort maxDrives,
					ushort * numDriveNumbers);

Boolean		IsPGPDiskFileType(OSType fileCreator, OSType fileType);
OSStatus	VerifyPGPDiskFileIsModifiable(const FSSpec *fileSpec);

void		GetErrorString(OSStatus err, StringPtr errorStr);
void		GetComboErrorString(CComboError	err, StringPtr errorStr);

#if PGP_BUSINESS_SECURITY	/* [ */

PGPError	GetADKInfo(PGPContextRef context, PGPBoolean *haveADK,
					PGPKeyID *keyID, PGPPublicKeyAlgorithm *algorithm );

#endif	/* ] PGP_BUSINESS_SECURITY */

extern short	gApplicationResFile;

